
THLM_FILE_LOOTMOD2_LOOTCHART_LUA = 1;

local THLM_HasPoints = false;
local THLM_Points = {};
THLM_SavedSpamChannel = "thwaiting";
THLM_SavedMainName = nil;

function THLM_LootChartOnLoad()
    SLASH_THLOADPOINTS1 = "/thloadpoints";
    SlashCmdList["THLOADPOINTS"] = function(msg)
        THLM_PointLoadFrame:Show();
    end;
    SLASH_THLOADITEMS1 = "/thloaditems";
    SlashCmdList["THLOADITEMS"] = function(msg)
        THLM_ItemLoadFrame:Show();
    end
    SLASH_THRAIDLIST1 = "/thraidlist";
    SlashCmdList["THRAIDLIST"] = function(msg)
        THLM_PopulateRaidList();
		THLM_RaidListFrame_WaitSpamButton:Show();
        THLM_RaidListFrame:Show();
        THLM_RaidListFrame_ScrollFrame_EditBox:SetFocus();
        THLM_RaidListFrame_ScrollFrame_EditBox:HighlightText(0);
    end;
end

local THLM_SpamResponseTo = nil;
local THLM_SpamExpireTime = nil;
local THLM_SpamReadyShowing = nil;
local THLM_LastSpamEndAt = nil;
local THLM_SpamSoundNext = nil;
local THLM_SPAMSOUND_SECS = 2;
StaticPopupDialogs["THLM_SPAM_READY"] = {
		text = "Are you here and available to raid?",
		button1 = "Yes",
		button2 = "No",
		OnAccept = function()
			StaticPopup_Hide("THLM_SPAM_READY");
			StaticPopup_Show("THLM_SPAM_NAME_PROMPT");
		end,
		OnCancel = function()
		end,
		OnShow = function()
			THLM_SpamSoundNext = GetTime();
			THLM_SpamReadyShowing = 1;
		end,
		OnHide = function()
			THLM_SpamReadyShowing = nil;
		end,
		OnUpdate = function()
			if THLM_SpamExpireTime then
				local timeToGo = THLM_SpamExpireTime - GetTime();
				if timeToGo <= 0 then
					StaticPopup_Hide("THLM_SPAM_READY");
					return;
				else
					local min = math.floor(timeToGo / 60);
					local sec = math.floor(timeToGo - (min * 60));
					if ( sec < 10 ) then
						sec = "0" .. sec;
					end;
					getglobal(this:GetName().."Text"):SetText("Are you here and ready to raid? ("..min..":"..sec..")");
				end
			else
				getglobal(this:GetName().."Text"):SetText("Are you here and ready to raid?");
			end
			local nowTime = GetTime();
			if (nowTime >= THLM_SpamSoundNext) then
				-- PlaySoundFile("Sound\\interface\\levelup2.wav");
				PlaySoundFile("Sound\\Doodad\\BellTollAlliance.wav");
				-- PlaySoundFile("Sound\\Creature\\Illidan\\BLACK_Illidan_WoundCrit02.wav");
				THLM_SpamSoundNext = GetTime() + THLM_SPAMSOUND_SECS;
			end
		end,
		timeout = 0,
		whileDead = 1,
		exclusive = 1
};
StaticPopupDialogs["THLM_SPAM_NAME_PROMPT"] = {
		text = "Enter your main's name below:",
		button1 = TEXT(ACCEPT),
		button2 = TEXT(CANCEL),
		hasEditBox = 1,
		maxLetters = 20,
		OnAccept = function()
			local mainname = getglobal(this:GetParent():GetName().."EditBox"):GetText();
			SendChatMessage("<THLootMod2> WaitingMain="..mainname, "WHISPER", nil, THLM_SpamResponseTo);
			THLM_SavedMainName = mainname;
		end,
		EditBoxOnEnterPressed = function()
		end,
		OnShow = function()
			THLM_SpamReadyShowing = 1;
			if not THLM_SavedMainName then
				THLM_SavedMainName = UnitName("player");
			end
			getglobal(this:GetName().."EditBox"):SetText(THLM_SavedMainName);
			getglobal(this:GetName().."EditBox"):SetFocus();
		end,
		OnHide = function()
			THLM_SpamReadyShowing = nil;
		end,
		OnUpdate = function()
			if THLM_SpamExpireTime then
				local timeToGo = THLM_SpamExpireTime - GetTime();
				if timeToGo <= 0 then
					StaticPopup_Hide("THLM_SPAM_NAME_PROMPT");
					return;
				else
					local min = math.floor(timeToGo / 60);
					local sec = math.floor(timeToGo - (min * 60));
					if ( sec < 10 ) then
						sec = "0" .. sec;
					end;
					getglobal(this:GetName().."Text"):SetText("Enter your main's name below: ("..min..":"..sec..")");
				end
			else
				getglobal(this:GetName().."Text"):SetText("Enter your main's name below:");
			end
		end,
		timeout = 0,
		whileDead = 1,
		exclusive = 1,
		hideOnEscape = 1
};
StaticPopupDialogs["THLM_GET_SPAM_CHANNEL"] = {
		text = "Which channel should be spammed?",
		button1 = TEXT(ACCEPT),
		button2 = TEXT(CANCEL),
		hasEditBox = 1,
		maxLetters = 20,
		OnAccept = function()
			local text = getglobal(this:GetParent():GetName().."EditBox"):GetText();
			THLM_StartWaitingSpam(text);
		end,
		EditBoxOnEnterPressed = function()
			local text = getglobal(this:GetParent():GetName().."EditBox"):GetText();
			THLM_StartWaitingSpam(text);
		end,
		OnShow = function()
			getglobal(this:GetName().."EditBox"):SetText(THLM_SavedSpamChannel);
			getglobal(this:GetName().."EditBox"):SetFocus();
		end,
		OnHide = function()
		end,
		timeout = 0,
		whileDead = 1,
		exclusive = 1,
		hideOnEscape = 1
};

function THLM_GetMainName(cname)
   local ng = GetNumGuildMembers(true);
   local x;
   for x = 1, ng do
      local zname, _, ranki, _, _, _, _, onote, _, _ = GetGuildRosterInfo(x);
      if zname == cname then
         if onote and not (onote=="") and not string.find(onote,":") then
            local y;
            for y = 1, ng do
               local szname = GetGuildRosterInfo(y);
               if (szname == onote) then
                  return onote;
               end
            end
         end
      end
   end
   return cname;
end

local THLM_SavedRaidList = {};

function THLM_PopulateRaidList()
   local i;
   local nr = GetNumRaidMembers();
   local ng = GetNumGuildMembers(true);
   local namelist = {};
   local res = "";
   for i = 1, nr do
      local name = UnitName("raid"..i);
      if name then
         name = THLM_GetMainName(name);
      end
	  table.insert(namelist, name);
   end
   table.sort(namelist);
   THLM_SavedRaidList = {};
   for i = 1, nr do
      res = res .. namelist[i] .. "\n";
	  THLM_SavedRaidList[namelist[i]] = {
	     charName = namelist[i],
	     registeredBy = "raid",
	  };
   end
   THLM_RaidListFrame_ScrollFrame_EditBox:SetText(res);
end

function THLM_ItemLoadExecute()
    if not THLM_PriorityTable then
       THLM_PriorityTable = {};
    end

    local txt = THLM_ItemLoadFrame_ScrollFrame_EditBox:GetText();
    THLM_ItemLoadFrame_ScrollFrame_EditBox:SetText("");
    THLM_ItemLoadFrame:Hide();

    local count = 0;
    for line in string.gmatch(txt, "[^\r\n]+") do
        line = string.gsub(line, "^%s+", "");
        --line = string.gsub(line, "%s+$", "");

        local cmatch = "([123456789FSNIA%-]R?[123456789]?)";
        local _, _, iname, war, pal, pri, dru, rog, mag, wrl, hnt, shm, spr, ens, fdr, fwa
              = string.find(line, "(.+)%s+"..cmatch.."%s+"..cmatch.."%s+"..cmatch.."%s+"..cmatch..
                                      "%s+"..cmatch.."%s+"..cmatch.."%s+"..cmatch.."%s+"..cmatch.."%s+"..cmatch..
                                      "%s+"..cmatch.."%s+"..cmatch.."%s+"..cmatch.."%s+"..cmatch);
        if iname then
           iname = string.gsub(iname, "^%s+", "");
           iname = string.gsub(iname, "%s+$", "");
           THLM_PriorityTable[iname] = { };
           THLM_Print("updating "..iname.." ...");
           THLM_PriorityTable[iname]["name"] = iname;
           THLM_PriorityTable[iname]["warrior"] = war;
           THLM_PriorityTable[iname]["paladin"] = pal;
           THLM_PriorityTable[iname]["priest"] = pri;
           THLM_PriorityTable[iname]["druid"] = dru;
           THLM_PriorityTable[iname]["rogue"] = rog;
           THLM_PriorityTable[iname]["mage"] = mag;
           THLM_PriorityTable[iname]["warlock"] = wrl;
           THLM_PriorityTable[iname]["hunter"] = hnt;
	   THLM_PriorityTable[iname]["shaman"] = shm;
	   THLM_PriorityTable[iname]["spriest"] = spr;
	   THLM_PriorityTable[iname]["enshaman"] = ens;
	   THLM_PriorityTable[iname]["fdruid"] = fdr;
	   THLM_PriorityTable[iname]["fwarrior"] = fwa;
           count = count + 1;
        end
    end
    THLM_Print("Priorities loaded for "..count.." items.");
end

function THLM_PointLoadExecute()
    THLM_HasPoints = false;
    THLM_Points = {};

    local txt = THLM_PointLoadFrame_ScrollFrame_EditBox:GetText();
    THLM_PointLoadFrame_ScrollFrame_EditBox:SetText("");
    THLM_PointLoadFrame:Hide();

    local line;

    local count = 0;
    for line in string.gmatch(txt, "[^\r\n]+") do
        line = string.gsub(line, "^%s+", "");
        --line = string.gsub(line, "%s+$", "");

        local _, _, pid, name, rank, level, class, earned, spent, adjust, current
              = string.find(line, "(%d+)%s+(%a+)%s+(%a+)%s+(%d+)%s+(%a+)%s+([^%s]+)%s+([^%s]+)%s+([^%s]+)%s+([^%s]+)%s+");
        --local _, _, pid, name, rank, level, class, earned, spent, adjust,
        --      current = string.find(line, "(%d+)%s+(%a+)%s+(%a+)%s+(%d+)%s+($a+)%s+(.+)%s+(.+)%s(.+)%s(.+)%s");
        if pid then
            count = count + 1;
            THLM_Points[name] = {};
            THLM_Points[name]["current"] = current + 0;
        end
    end

    THLM_HasPoints = true;
    THLM_Print("Points loaded for "..count.." players.");
end

function THLM_CalcMaxPoints(pts)
    if (pts < 0) then
        return 0;
    else
        return pts;
    end
end

function THLM_CalcMinPoints(pts)
    local min = 10;
    if (GetRealZoneText()=="Ruins of Ahn'Qiraj" or GetMinimapZoneText()=="Ruins of Ahn'Qiraj" or
        GetSubZoneText()=="Ruins of Ahn'Qiraj" or GetZoneText()=="Ruins of Ahn'Qiraj") then
       min = 3;
    end
    return min;

--[[
    if (pts < 50) then
        return 5;
    elseif (pts < 100) then
        return 10;
    elseif (pts < 150) then
        return 20;
    else
        local xpt = math.ceil(pts * 0.2);
        return xpt;
    end
--]]
end

function THLM_DistributePointInfo()
	local numRaidMembers = GetNumRaidMembers();
	local i;
	for i = 1, numRaidMembers do
		local thisName = UnitName("raid"..i);
		local mainName = thisName;
		if thisName then
			mainname = THLM_GetMainName(thisName);
		end
		if (mainName and THLM_Points[mainName]) then
			local thisPoints = THLM_Points[mainName]["current"];
			local minBid = THLM_CalcMinPoints(thisPoints);
			local maxBid = THLM_CalcMaxPoints(thisPoints);
			THCH_SendWhisper("_THLM_PT " .. thisName .. thisPoints .. "+Zzzz0", thisName);
			THCH_SendWhisper("_THLM_MB " .. thisName .. minBid .. "+Zzzz0", thisName);
			THCH_SendWhisper("_THLM_XB " .. thisName .. maxBid .. "+Zzzz0", thisName);
		end
	end
end

function THLM_DistributePointInfo_OLD()
    local numRaidMembers = GetNumRaidMembers();
    local i;
    local xc = 0;
    local tout = "";
    local minout = "";
    local maxout = "";
    for i = 1, numRaidMembers do
        local thisName = UnitName("raid"..i);
        local mainName = thisName;
        if thisName then
           mainName = THLM_GetMainName(thisName);
        end
        if (mainName and THLM_Points[mainName]) then
            local thisPoints = THLM_Points[mainName]["current"];

            if (xc > 0) then
                tout = tout .. "+";
                minout = minout .. "+";
                maxout = maxout .. "+";
            end
            tout = tout .. thisName .. thisPoints;
            minout = minout .. thisName .. THLM_CalcMinPoints(thisPoints);
            maxout = maxout .. thisName .. THLM_CalcMaxPoints(thisPoints);
            xc = xc + 1;

            if (xc == 5) then
                --CT_RA_SendMessage("_THLM_PT "..tout);
                --CT_RA_SendMessage("_THLM_MB "..minout);
                --CT_RA_SendMessage("_THLM_XB "..maxout);
                THCH_SendMessage("_THLM_PT "..tout, "RAID");
                THCH_SendMessage("_THLM_MB "..minout, "RAID");
                THCH_SendMessage("_THLM_XB "..maxout, "RAID");
                tout = "";
                minout = "";
                maxout = "";
                xc = 0;
            end
        end
    end
    if (xc > 0) then
        --CT_RA_SendMessage("_THLM_PT "..tout);
        --CT_RA_SendMessage("_THLM_MB "..minout);
        --CT_RA_SendMessage("_THLM_XB "..maxout);
        THCH_SendMessage("_THLM_PT "..tout, "RAID");
        THCH_SendMessage("_THLM_MB "..minout, "RAID");
        THCH_SendMessage("_THLM_XB "..maxout, "RAID");
    end
end

local THLM_SPAM_TIMER_MINS = 3;
local THLM_SPAM_ADDON_MSG_INTERVAL = 10;
local THLM_SpamTime_2 = nil;
local THLM_SpamTime_3 = nil;
local THLM_SpamTime_Done = nil;
local THLM_NextSpamAddonMessage = nil;
local THLM_CurrentList = {};

function THLM_SendSpam()
	local pname = UnitName("player");
	local ch, _ = GetChannelName(THLM_SavedSpamChannel);
	if ch then
		SendChatMessage("*** Send whispers with your main's name to "..pname.." within the next "..
				THLM_SPAM_TIMER_MINS.." minutes for credit for this hour! ***",
				"CHANNEL", nil, ch);
	end
	if THLM_SpamTime_2 and THLM_SpamTime_2 < GetTime() then
		THLM_SpamTime_2 = nil;
	end
	if THLM_SpamTime_3 and THLM_SpamTime_3 < GetTime() then
		THLM_SpamTime_3 = nil;
	end
end

function THLM_SpamWaitingChannel()
	if THLM_SpamTime_Done then
		THLM_Print("You are already spamming!");
		return;
	end

	StaticPopup_Show("THLM_GET_SPAM_CHANNEL", "", "");
end

function THLM_StartWaitingSpam(chan)
	THLM_SavedSpamChannel = chan;
 	local currentTime = GetTime();
	THLM_CurrentList = {};
	THLM_SendSpam();
	THLM_SpamTime_2 = currentTime + 1;
	THLM_SpamTime_3 = currentTime + 2;
	THLM_SpamTime_Done = currentTime + (THLM_SPAM_TIMER_MINS * 60) + 5;
    THLM_NextSpamAddonMessage = currentTime;
	THLM_SpamTimerWindow_Title:Show();
	THLM_SpamTimerWindow_TimeRemaining:Show();
	THLM_SpamTimerWindow_FinishButton:Hide();
	THLM_SpamTimerWindow:Show();
end

function THLM_SpamUpdateTick()
	local curTime = GetTime();
	if THLM_SpamTime_2 and (curTime > THLM_SpamTime_2) then
		THLM_SendSpam();
	end
	if THLM_SpamTime_3 and (curTime > THLM_SpamTime_3) then
		THLM_SendSpam();
	end
	if THLM_NextSpamAddonMessage and THLM_SpamTime_Done and (curTime > THLM_NextSpamAddonMessage) then
		THLM_NextSpamAddonMessage = curTime + THLM_SPAM_ADDON_MSG_INTERVAL;
		local sectogo = math.floor(THLM_SpamTime_Done - curTime - 5);
		THCH_SendMessage("_THLM2_SA endat="..math.floor(THLM_SpamTime_Done).." sec=" .. sectogo.." chan="..THLM_SavedSpamChannel, "GUILD");
	end
	if THLM_SpamTime_Done and (curTime > THLM_SpamTime_Done) then
		THLM_SpamTime_Done = nil;
		THLM_NextSpamAddonMessage = nil;
		THLM_SpamTimerWindow_Title:Hide();
		THLM_SpamTimerWindow_TimeRemaining:Hide();
		THLM_SpamTimerWindow_FinishButton:Show();
	elseif THLM_SpamTime_Done then
		local timeToGo = THLM_SpamTime_Done - curTime;
		local mins = math.floor(timeToGo / 60);
		local secs = math.floor(timeToGo - (mins * 60));
		if (secs < 10) then
			secs = "0" .. secs;
		end
		THLM_SpamTimerWindow_TimeRemaining:SetText( mins .. ":" .. secs );
	end
end

function THLM_IsPlayerInMyRaid(checkwho)
	local inRaid = nil;
	local nr = GetNumRaidMembers();
	if nr then
		local i;
		for i = 1, GetNumRaidMembers() do
			local name = GetRaidRosterInfo(i);
			--THLM_Print("name="..name.." checkwho="..checkwho);
			if (name == checkwho) then
				inRaid = 1;
			end
		end
	end
	return inRaid;
end

function THLM_CheckForSpamMessage()
	-- called by CHAT_MSG_CHANNEL event handler
	local lookfor = "*** Send whispers with your main's name to ";

	if (arg1 and string.find(arg1, lookfor)) then
		local _, _, minCount = string.find(arg1, "(%d+)");
		if minCount and not THLM_SpamReadyShowing then
			if not THLM_IsPlayerInMyRaid(arg2) then
				THLM_SpamResponseTo = arg2;
				THLM_SpamExpireTime = GetTime() + (minCount * 60);
				StaticPopup_Show("THLM_SPAM_READY");
			end
	 	end
	end
end

function THLM_HandleAddonSpamAlert(msg, fromwho)
	local _, _, secRemain = string.find(msg, "sec=(%d+)");
	local _, _, endAt = string.find(msg, "endat=(%d+)");
	local _, _, chan = string.find(msg, "chan=(%w+)");
	local ch = 0;
	if chan then
		ch, _ = GetChannelName(chan);
		if not ch then
			ch = 0;
		else
			ch = 0 + ch;
		end
	end
	if secRemain and endAt and (not THLM_SpamReadyShowing) and ch>0 then
		if not THLM_IsPlayerInMyRaid(fromwho) and not (THLM_LastSpamEndAt == endAt) then
		    THLM_LastSpamEndAt = endAt;
			THLM_SpamResponseTo = fromwho;
			THLM_SpamExpireTime = GetTime() + secRemain;
			StaticPopup_Show("THLM_SPAM_READY");
		end
	elseif secRemain and endAt and THLM_SpamReadyShowing and ch>0 then
		THLM_LastSpamEndAt = endAt;
	end
end

function THLM_CheckForMainWhisper()
	-- called by CHAT_MSG_WHISPER event handler
	if THLM_SpamTime_Done then
		local wtext = arg1;
		local wfrom = arg2;
		local _, _, wparsed = string.find(wtext, "WaitingMain=(%w+)");
		if wparsed then
			if THLM_RegisterWaitingMain(wparsed, wfrom) then
				THLM_Print(" --> Registered attendance for "..wtext.." by "..wfrom..".");
			else
				SendChatMessage("<THLootMod2> Could not note attendance for '" .. wparsed .. "'.", "WHISPER", nil, wfrom);
			end
		else
			if THLM_RegisterWaitingMain(wtext, wfrom) then
				THLM_Print(" --> Registered attendance for "..wtext.." by "..wfrom..".");
			--else
			--	THLM_Print("This does not appear to be a valid character to register attendance for.");
			end
		end
	end
	if (string.find(arg1, "<THLootMod2>") and string.find(arg1, " attendance noted.")) then
		THLM_Print("Raid attendance noted by ".. arg2 ..".");
	end
	if (string.find(arg1, "<THLootMod2>") and string.find(arg1, "Could not note attendance")) then
		THLM_Print("ATTENDANCE NOT NOTED -- Please contact ".. arg2 .." manually.");
	end
end

function THLM_RegisterWaitingMain(mname, wfrom)
	if not mname then
		return;
	end
	mname = string.lower(mname);
	--THLM_Print("looking for "..mname.."...");
	for i = 1, GetNumGuildMembers(true) do
		local name = GetGuildRosterInfo(i);
		local lname = string.lower(name);
		if (lname == mname) then
			name = THLM_GetMainName(name);
			SendChatMessage("<THLootMod2> Character '"..name.."' attendance noted.", "WHISPER", nil, wfrom);
			THLM_CurrentList[name] = {
				charName = name,
				registeredBy = wfrom,
			};
			return 1;
		end
	end
	return nil;
end

function THLM_ShowListWithSpam()
	local totalList = {};
	local nr = 0;
	table.foreach(THLM_SavedRaidList, function(k,v)
		table.insert(totalList, v.charName);
		nr = nr + 1;
	end);
	table.foreach(THLM_CurrentList, function(k,v)
		table.insert(totalList, v.charName);
		nr = nr + 1;
	end);
	table.sort(totalList);
	local res = "";
	for i = 1, nr do
		res = res .. totalList[i] .. "\n";
	end
	THLM_RaidListFrame_ScrollFrame_EditBox:SetText(res);
	THLM_RaidListFrame_WaitSpamButton:Hide();
	THLM_RaidListFrame:Show();
	THLM_RaidListFrame_ScrollFrame_EditBox:SetFocus();
	THLM_RaidListFrame_ScrollFrame_EditBox:HighlightText(0);
end
